﻿using System;

namespace FeedParserApp.FeedParserServiceBLL
{
    public class FeedParserFactory
    {
        public static FeedParser Create(string parserType)
        {
            switch (parserType.ToLower())
            {
                case "rss":
                    return new RssParser();
                case "rdf":
                    return new RdfParser();
                case "atom":
                    return new AtomParser();
                default:
                    throw new ArgumentException("Parser type is not valid", nameof(parserType));
            }
        }
    }
}
