﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace FeedParserApp.FeedParserServiceBLL
{
    public class AtomParser : FeedParser
    {
        public override IList<Item> Parse(FeedUrl feedUrl)
        {
			try
			{
				XDocument doc = XDocument.Load(feedUrl.Url);
				// Feed/Entry
				var entries = from item in doc.Root.Elements().Where(i => i.Name.LocalName == "entry")
							  select new Item
							  {
								  FeedType = FeedType.Atom,
								  Content = item.Elements().First(i => i.Name.LocalName == "content").Value,
								  Link = item.Elements().First(i => i.Name.LocalName == "link").Attribute("href").Value,
								  PublishDate = DateTimeParser.ParseDate(item.Elements().First(i => i.Name.LocalName == "published").Value),
								  Title = item.Elements().First(i => i.Name.LocalName == "title").Value
							  };
				return entries.ToList();
			}
			catch(Exception ex)
			{
				throw ParseException.Create(ex,feedUrl.Url);
			}
		}
    }
}
