﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace FeedParserApp.FeedParserServiceBLL
{
    public class RdfParser : FeedParser
    {
        public override IList<Item> Parse(FeedUrl feedUrl)
        {
			try
			{
				XDocument doc = XDocument.Load(feedUrl.Url);
				// <item> is under the root
				var entries = from item in doc.Root.Descendants().Where(i => i.Name.LocalName == "item")
							  select new Item
							  {
								  FeedType = FeedType.RDF,
								  Content = item.Elements().First(i => i.Name.LocalName == "description").Value,
								  Link = item.Elements().First(i => i.Name.LocalName == "link").Value,
								  PublishDate = DateTimeParser.ParseDate(item.Elements().First(i => i.Name.LocalName == "date").Value),
								  Title = item.Elements().First(i => i.Name.LocalName == "title").Value
							  };
				return entries.ToList();
			}
			catch (Exception ex)
			{
				throw ParseException.Create(ex,feedUrl.Url);
			}
		}
    }
}
