﻿using System;

namespace FeedParserApp.FeedParserServiceBLL
{
    public class FeedUrl
    {
        private string _url;
        public string Url { get => _url; }

        private FeedUrl(string url)
        {
            _url = url;
        }

        public static FeedUrl Create(string url)
        {
            try
            {
                Uri uri = new Uri(url);
                return new FeedUrl(url);
            }
            catch(ArgumentNullException)
            {
                throw FeedUrlException.Create($"Url can not be empty");
            }
            catch(UriFormatException)
            {
                if (string.IsNullOrEmpty(url))
                    throw FeedUrlException.Create($"Url can not be empty");
                else
                    throw FeedUrlException.Create($"The format of the url {url} is incorrect");
            }
        }
    }
}
