﻿using FeedParserApp.FeedParserServiceBLL;
using FeedParserApp.UIControls;
using System.Collections.Generic;
using System.Windows.Forms;

namespace FeedParserApp
{
    public partial class Form1 : Form
    {
        private FeedParser _feedParser;
        public Form1()
        {
            InitializeComponent();
            rbtRss.Checked = true;
        }

        private void btnParse_Click(object sender, System.EventArgs e)
        {
            try
            {
                var feedUrl = FeedUrl.Create(txtFeed.Text);
                var feedItemList = _feedParser.Parse(feedUrl);
                CreateControls(feedItemList);
            }
            catch(FeedUrlException ex)
            {
                MessageBox.Show(ex.Message, AppCommon.AppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch(ParseException ex)
            {
                MessageBox.Show(ex.Message, AppCommon.AppName, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void CreateControls(IEnumerable<Item> feedParserItems)
        {
            foreach(var item in feedParserItems)
            {
                var feedControl = FeedControl.Create(FeedControlModel.CreateFromItem(item));
                feedPanel.Controls.Add(feedControl);
            }
        }

        private void FeedParser_CheckedChanged(object sender, System.EventArgs e)
        {
            var rbtFeedParser = sender as RadioButton;
            _feedParser = FeedParserFactory.Create(rbtFeedParser?.Text ?? string.Empty);
        }
    }
}
